<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"/>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onLoadPaging()">
    <div class="container">
        <div class="text-center">
            <h2>Danh sách người dùng đăng ký</h2>
        </div>
        <table class="table table-bordered table-striped table-hover" id="tbl-users">
            <thead>
                <tr>
                    <th>Id</th>
                    <th>Firstname</th>
                    <th>Lastname</th>
                    <th>Country</th>
                    <th>Subject</th>
                    <th>Customer Type</th>
                    <th>Register Status</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody></tbody>
        </table>
    </div>
    
</body>
<script>
    "use strict";
    //* REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện
    function onLoadPaging(){
        "use strict";
        //thu thập dữ liệu từ query string
        var vUrlString = window.location.href;
        var vUrl = new URL(vUrlString);
        //get parameters
        var vId = vUrl.searchParams.get("id");
        console.log(vId);
        callAPIGetDataUser(vId);
    }
    // hàm load user data dùng Ajax
    function callAPIGetDataUser() {
        "use strict";
        $.ajax({
            url: "http://203.171.20.210:8080/devcamp-register-java-api/users",
            type: "GET",
            dataType: "json",  //added data type
            success:function(res) {
                console.log(res);
                loadUserDataToTable(res);
            },
            error: function (ajaxContext) {
                alert(ajaxContext.responseText);
            },
        });
    }
    //gán event handler cho nu sửa
    $("#tbl-users").on("click", ".btn-edit", onBtnEditClick);
    //gán sự kiện cho nút xóa
    $("#tbl-users").on("click", ".btn-delete", onBtnDeleteClick);
    //* REGION 4 - common functions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình
    //hàm đc gọi khi bấm nút sửa
    function onBtnEditClick() {
        "use strict";
        console.log("Bấm nút Sửa, Id của user tương ứng là: " + $(this).data("id"));
        const vDETAIL_FORM_URL = "updateUser.html";
        var vUrlToOpenPage = vDETAIL_FORM_URL + "?" + "id" + $(this).data("id");
        window.location.href = vUrlToOpenPage;
    }
    //hàm đc gọi khi bấm nút xóa
    function onBtnDeleteClick() {
        "use strict";
        console.log("Bấm nút Xóa, Id của user tương ứng là: " + $(this).data("id"));
    }
    // hàm load dữ liệu lên table
    function loadUserDataToTable(paramUserData) {
        for (var bI = 0; bI < paramUserData.length; bI++) {
            //tạo row
            var bNewRow = $("<tr>").appendTo("#tbl-users tbody");
            //tạo cell (cột) các trường
            $("<td>").html(paramUserData[bI].id).appendTo(bNewRow);
            $("<td>").html(paramUserData[bI].firstname).appendTo(bNewRow);
            $("<td>").html(paramUserData[bI].lastname).appendTo(bNewRow);
            $("<td>").html(paramUserData[bI].country).appendTo(bNewRow);
            $("<td>").html(paramUserData[bI].subject).appendTo(bNewRow);
            $("<td>").html(paramUserData[bI].customerType).appendTo(bNewRow);
            $("<td>").html(paramUserData[bI].registerStatus).appendTo(bNewRow);
            //tạo cột chứa nút sửa và xóa
            var bColAction = $("<tr>").appendTo(bNewRow); //cột action
            //tạo nút sửa (Edit)
            var bButtonEdit = $("<button>")
                .attr("class", "btn btn-primary col-6 btn-edit")
                .html("Sửa");
            bButtonEdit.attr("data-id", paramUserData[bI].id);
            bButtonEdit.attr("data-firstname", paramUserData[bI].firstname);
            bButtonEdit.attr("data-lastname", paramUserData[bI].lastname);
            bButtonEdit.attr("data-country", paramUserData[bI].country);
            bButtonEdit.attr("data-subject", paramUserData[bI].subject);
            bButtonEdit.attr("data-customerType", paramUserData[bI].customerType);
            bButtonEdit.attr("data-registerStatus", paramUserData[bI].registerStatus);
            //thêm vào cột action
            bButtonEdit.appendTo(bColAction);
            //tạo nút xóa
            var bButtonDelete = $("<button>")
                .attr("class", "btn btn-danger col-6 btn-delete")
                .html("Xóa");
            bButtonDelete.attr("data-id", paramUserData[bI].id);
            bButtonDelete.attr("data-firstname", paramUserData[bI].firstname);
            bButtonDelete.attr("data-lastname", paramUserData[bI].lastname);
            bButtonDelete.attr("data-country", paramUserData[bI].country);
            bButtonDelete.attr("data-subject", paramUserData[bI].subject);
            bButtonDelete.attr("data-customerType", paramUserData[bI].customerType);
            bButtonDelete.attr("data-registerStatus", paramUserData[bI].registerStatus);
            //thêm vào cột action
            bButtonDelete.appendTo(bColAction);
        }
    }
</script>
</html>